"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/icon/style");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

require("antd/lib/modal/style");

var _modal = _interopRequireDefault(require("antd/lib/modal"));

var _react = _interopRequireWildcard(require("react"));

var _rcTabs = _interopRequireWildcard(require("@canner/rc-tabs"));

var _TabContent = _interopRequireDefault(require("@canner/rc-tabs/lib/TabContent"));

var _ScrollableInkTabBar = _interopRequireDefault(require("@canner/rc-tabs/lib/ScrollableInkTabBar"));

var _reactSortablejs = _interopRequireDefault(require("react-sortablejs"));

var _reactIntl = require("react-intl");

var _cannerHelpers = require("canner-helpers");

var _class, _class2, _temp;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var confirm = _modal.default.confirm;

var TabUi = (0, _reactIntl.injectIntl)(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(TabUi, _Component);

  function TabUi(props) {
    var _this;

    _classCallCheck(this, TabUi);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TabUi).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "prevIndex", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleTabChange", function (key) {
      _this.setState({
        activeKey: key
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleCreate", function () {
      var _this$props = _this.props,
          value = _this$props.value,
          refId = _this$props.refId,
          onChange = _this$props.onChange;
      var size = value.length;
      onChange(refId, 'create');

      _this.setState({
        activeKey: "".concat(size)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleDelete", function (index) {
      var _this$props2 = _this.props,
          intl = _this$props2.intl,
          onChange = _this$props2.onChange,
          deploy = _this$props2.deploy,
          value = _this$props2.value,
          refId = _this$props2.refId;

      var that = _assertThisInitialized(_assertThisInitialized(_this));

      confirm({
        title: intl.formatMessage({
          id: "array.tab.delete.confirm"
        }),
        onOk: function onOk() {
          onChange(refId.child(index), "delete").then(function () {
            if (deploy) {
              return deploy(refId);
            }

            return Promise.resolve();
          }).then(function () {
            that.setState({
              activeKey: "".concat(value.length - 2)
            });
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "dragItem", function (order, sortable, evt) {
      var newIndex = evt.newIndex,
          oldIndex = evt.oldIndex;
      var _this$props3 = _this.props,
          refId = _this$props3.refId,
          onChange = _this$props3.onChange;
      var prevRefId = refId.child(oldIndex - 1);
      var currRefId = refId.child(newIndex - 1);

      _this.setState({
        activeKey: "".concat(newIndex - 1)
      });

      onChange({
        firstRefId: prevRefId,
        secondRefId: currRefId
      }, "swap");
    });

    _this.state = {
      activeKey: '0'
    };
    return _this;
  }

  _createClass(TabUi, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      // change active key when user delete last tab
      var activeKey = this.state.activeKey;
      var valueSize = nextProps.value.length;

      if (valueSize < Number(activeKey) + 1) {
        activeKey = valueSize - 1;
        this.setState({
          activeKey: String(activeKey)
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          value = _this$props4.value,
          refId = _this$props4.refId,
          uiParams = _this$props4.uiParams,
          intl = _this$props4.intl;
      var activeKey = this.state.activeKey;
      var position = uiParams.position || "top";
      var panelFields = []; // set array content

      value.forEach(function (item, i) {
        var thisId = refId.child(i); // generate panel title

        var title;
        var defaultTitle = "".concat(intl.formatMessage({
          id: "array.tab.item"
        }), " ").concat(i + 1);

        if (uiParams.titleKey) {
          title = item[uiParams.titleKey] || defaultTitle;
        } else if (uiParams.titlePrefix) {
          title = "".concat(uiParams.titlePrefix).concat(i + 1) || defaultTitle;
        } else {
          title = defaultTitle;
        }

        var deleteBtn = function deleteBtn(index) {
          return _react.default.createElement(_icon.default, {
            type: "close-circle",
            onClick: function onClick() {
              return _this2.handleDelete(index);
            }
          });
        };

        if (position === 'right' && activeKey === "".concat(i)) {
          title = [title, ' ', deleteBtn(i)];
        } else if (activeKey === "".concat(i)) {
          title = [deleteBtn(i), ' ', title];
        }

        panelFields.push(_react.default.createElement(_rcTabs.TabPane, {
          tab: title,
          id: thisId,
          key: "".concat(i),
          style: {
            overflow: 'hidden',
            padding: '0 10px'
          }
        }, _react.default.createElement(_cannerHelpers.Item, {
          refId: thisId
        }), thisId.getPathArr().length === 2 && _react.default.createElement("div", null, _react.default.createElement(_cannerHelpers.ConfirmButton, {
          refId: thisId
        }), _react.default.createElement(_cannerHelpers.ResetButton, {
          refId: thisId
        }))));
      });
      return _react.default.createElement("div", {
        style: {
          width: '100%'
        }
      }, _react.default.createElement(_rcTabs.default, {
        prefixCls: "ant-tabs",
        className: position === 'left' || position === 'right' ? 'ant-tabs-vertical' : null,
        activeKey: "".concat(activeKey),
        tabBarPosition: position,
        navWrapper: function navWrapper(content) {
          return _react.default.createElement(_reactSortablejs.default, {
            onChange: _this2.dragItem
          }, content);
        },
        renderTabBar: function renderTabBar() {
          return _react.default.createElement(_ScrollableInkTabBar.default, {
            extraContent: _react.default.createElement(_button.default, {
              style: {
                margin: '6px'
              },
              onClick: _this2.handleCreate
            }, "+ Add")
          });
        },
        renderTabContent: function renderTabContent() {
          return _react.default.createElement(_TabContent.default, {
            tabBarPosition: position,
            animated: false
          });
        },
        onChange: this.handleTabChange
      }, panelFields));
    }
  }]);

  return TabUi;
}(_react.Component), _defineProperty(_class2, "defaultProps", {
  uiParams: {},
  value: []
}), _temp)) || _class;

exports.default = TabUi;